---
- name: Mount External Hard
  hosts: localhost
  gather_facts: false
  tasks:
    - name: Wait for system to become reachable
      wait_for_connection:
        timeout: 300

    - name: Gather facts for first time
      setup:

    - name: Mount disk for Linux
      when:
      - ansible_distribution == 'CentOS' or ansible_distribution == 'Ubuntu'
      block:
      - name: Get disks without file system
        shell: lsblk -p -o NAME,FSTYPE -dn | awk '$2 == "" {print $1}'
        register: disks_to_format

      - name: Create list of block devices
        set_fact:
          block_devices_to_format: "{{ block_devices_to_format|default([]) + [ item ] }}"
        loop: "{{ disks_to_format.stdout_lines }}"

      - name: Partition disk
        parted:
          device: "{{ item.device }}"
          number: 1
          flags: [ lvm ]
          state: present
        when: item.device is defined and item.device in block_devices_to_format
        with_items: "{{ volumes | default([]) }}"

      - name: Format disk
        filesystem:
          fstype: xfs
          dev: "{{ item.device }}"
        when: item.device is defined and item.device in block_devices_to_format
        with_items: "{{ volumes | default([]) }}"

      - name: Mount disk
        mount:
          fstype: xfs
          src: "{{ item.1.device }}"
          path: "/data/volume_{{ item.0 }}"
          state: mounted
        when: item.1.device is defined
        with_indexed_items: "{{ volumes | default([]) }}"

      - name: Change permissions
        file:
          path: "/data/volume_{{ item.0 }}"
          mode: 0777
        when: item.1.device is defined
        with_indexed_items: "{{ volumes | default([]) }}"
